/* static extention handling shared library. */
#include <stdio.h>
#include <getopt.h>
#include <sys/types.h>
#include "NAT/ipnatctl.h"

static struct option opts[] = {
	{0}
};

/* Function which prints out usage message. */
static void
help(void)
{
	printf(
"static v%s options:\n",
NETFILTER_VERSION);
}

/* Function which parses command options; returns true if it
   ate an option */
static int parse(int c, char **argv, void *options, unsigned int *flags)
{
	return 0;
}

/* Check flags. */
static void finalize(const struct ip_nat_rule_user *rule,
		     void *options, unsigned int flags)
{
	/* Start of map == start of from range. */
	if (rule->maniptype == IP_NAT_MANIP_SRC)
		*(u_int32_t *)options 
			= (rule->match.src.ip & rule->mask.src.ip);
	else
		*(u_int32_t *)options 
			= (rule->match.dst.ip & rule->mask.dst.ip);
}

static struct ipnat_mapping static_map =
{ NULL, "static", sizeof(u_int32_t), help, parse, finalize, opts };

void
_init(void)
{
	register_mapping(&static_map);
}
