#! /bin/sh

# Stolen from 04ipchains-compat/01admin.sh
# Simple script to test that inserting & deleting rules and chains works.

# Need job control.
set -m

../packet-filter/userspace/iptables -N foo || exit 1
../packet-filter/userspace/iptables -N foo 2>/dev/null && exit 1

../packet-filter/userspace/iptables -X foo || exit 1
../packet-filter/userspace/iptables -X foo 2>/dev/null && exit 1

# Can't delete builtins.
../packet-filter/userspace/iptables -X INPUT 2>/dev/null && exit 1
../packet-filter/userspace/iptables -X FORWARD 2>/dev/null && exit 1
../packet-filter/userspace/iptables -X OUTPUT 2>/dev/null && exit 1
../packet-filter/userspace/iptables -X DROP 2>/dev/null && exit 1
../packet-filter/userspace/iptables -X ACCEPT 2>/dev/null && exit 1
../packet-filter/userspace/iptables -X RETURN 2>/dev/null && exit 1

# Can't create builtins.
../packet-filter/userspace/iptables -N INPUT 2>/dev/null && exit 1
../packet-filter/userspace/iptables -N FORWARD 2>/dev/null && exit 1
../packet-filter/userspace/iptables -N OUTPUT 2>/dev/null && exit 1
../packet-filter/userspace/iptables -N DROP 2>/dev/null && exit 1
../packet-filter/userspace/iptables -N ACCEPT 2>/dev/null && exit 1
../packet-filter/userspace/iptables -N RETURN 2>/dev/null && exit 1

# Insert test.
../packet-filter/userspace/iptables -N foo || exit 1
../packet-filter/userspace/iptables -A foo || exit 1

# Can't delete non-empty.
../packet-filter/userspace/iptables -X foo 2>/dev/null && exit 1

# Delete tests.
../packet-filter/userspace/iptables -D foo || exit 1
../packet-filter/userspace/iptables -A foo || exit 1
../packet-filter/userspace/iptables -D foo 1 || exit 1

# Can delete empty.
../packet-filter/userspace/iptables -X foo || exit 1

# Can't delete referred-to.
../packet-filter/userspace/iptables -N foo || exit 1
../packet-filter/userspace/iptables -N foo2 || exit 1
../packet-filter/userspace/iptables -A foo -j foo2 || exit 1
../packet-filter/userspace/iptables -X foo2 2>/dev/null && exit 1

# Can't delete non-empty referred-to.
../packet-filter/userspace/iptables -A foo2 || exit 1
../packet-filter/userspace/iptables -X foo2 2>/dev/null && exit 1

# Clear reference and check.
../packet-filter/userspace/iptables -D foo 1 || exit 1
../packet-filter/userspace/iptables -X foo2 2>/dev/null && exit 1

# Clear chain and delete.
../packet-filter/userspace/iptables -D foo2 1 || exit 1
../packet-filter/userspace/iptables -X foo2 || exit 1

# Test deletion of all chains.
../packet-filter/userspace/iptables -N foo2 || exit 1
../packet-filter/userspace/iptables -X || exit 1

# Now new creation should be OK.
../packet-filter/userspace/iptables -N foo || exit 1
../packet-filter/userspace/iptables -N foo2 || exit 1

exit 0
