#! /bin/sh

# Need job control.
set -m

# Test the various different interface match possibilities

for i in "" "-i t+" "-i ta+" "-i tap+" "-i tap0+" "-i tap0"
do
    ../packet-filter/userspace/iptables -A FORWARD $i -j ACCEPT || exit 1
    ./rcv_ip 2 1 < /dev/tap1 > $TMPFILE &
    sleep 1
    ./gen_ip $TAP0NET.2 $TAP1NET.2 100 1 8 0 55 57 > /dev/tap0

    if wait %./rcv_ip; then :
    else
	echo ./rcv_ip for \`$i\' failed:
	cat $TMPFILE
	exit 1
    fi
    ../packet-filter/userspace/iptables -F FORWARD || exit 1
done

../packet-filter/userspace/iptables -P FORWARD ACCEPT || exit 1
for i in "-i a+" "-i at+" "-i tpa+" "-i tap1+" "-i tap1"
do
    ../packet-filter/userspace/iptables -A FORWARD $i -j DROP || exit 1
    ./rcv_ip 2 1 < /dev/tap1 > $TMPFILE &
    sleep 1
    ./gen_ip $TAP0NET.2 $TAP1NET.2 100 1 8 0 55 57 > /dev/tap0

    if wait %./rcv_ip; then :
    else
	echo ./rcv_ip for \`$i\' failed:
	cat $TMPFILE
	exit 1
    fi
    ../packet-filter/userspace/iptables -F FORWARD || exit 1
done

../packet-filter/userspace/iptables -P FORWARD DROP || exit 1

# Output interfaces.
for i in "" "-o t+" "-o ta+" "-o tap+" "-o tap1+" "-o tap1"
do
    ../packet-filter/userspace/iptables -A FORWARD $i -j ACCEPT || exit 1
    ./rcv_ip 2 1 < /dev/tap1 > $TMPFILE &
    sleep 1
    ./gen_ip $TAP0NET.2 $TAP1NET.2 100 1 8 0 55 57 > /dev/tap0

    if wait %./rcv_ip; then :
    else
	echo ./rcv_ip for \`$i\' failed:
	cat $TMPFILE
	exit 1
    fi
    ../packet-filter/userspace/iptables -F FORWARD || exit 1
done

../packet-filter/userspace/iptables -P FORWARD ACCEPT || exit 1
for i in "-o a+" "-o at+" "-o tpa+" "-o tap0+" "-o tap0"
do
    ../packet-filter/userspace/iptables -A FORWARD $i -j DROP || exit 1
    ./rcv_ip 2 1 < /dev/tap1 > $TMPFILE &
    sleep 1
    ./gen_ip $TAP0NET.2 $TAP1NET.2 100 1 8 0 55 57 > /dev/tap0

    if wait %./rcv_ip; then :
    else
	echo ./rcv_ip for \`$i\' failed:
	cat $TMPFILE
	exit 1
    fi
    ../packet-filter/userspace/iptables -F FORWARD || exit 1
done

exit 0
