#! /bin/sh

# BUG 0007 - Thanks to Adam Kumiszcza's report.
../packet-filter/userspace/iptables -h tos > $TMPFILE || exit 1

grep -i 'minimi[sz]e-cost' < $TMPFILE > /dev/null || exit 1
grep -i 'minimi[sz]e-delay' < $TMPFILE > /dev/null || exit 1
grep -i 'maximi[sz]e-throughput' < $TMPFILE > /dev/null || exit 1
grep -i 'maximi[sz]e-reliability' < $TMPFILE > /dev/null || exit 1

# Need job control.
set -m

# Test the various different protocol match possibilities.

for i in "" "-t 0" "-t ! 8" "-t 0x00" "-t ! minimize-cost" "-t ! minimize-delay" "-t ! maximize-throughput" "-t ! maximize-reliability"
do
    ../packet-filter/userspace/iptables -A FORWARD $i -j ACCEPT || exit 1
    ./rcv_ip 2 1 < /dev/tap1 > $TMPFILE &
    sleep 1
    ./gen_ip $TAP0NET.2 $TAP1NET.2 100 1 8 0 55 57 > /dev/tap0

    if wait %./rcv_ip; then :
    else
	echo ./rcv_ip failed for \`$i\':
	cat $TMPFILE
	exit 1
    fi
    ../packet-filter/userspace/iptables -F FORWARD || exit 1
done

../packet-filter/userspace/iptables -P FORWARD ACCEPT || exit 1
for i in "-t ! 0" "-t 8" "-t 0xA0" "-t minimize-cost" "-t minimize-delay" "-t maximize-throughput" "-t maximize-reliability"
do
    ../packet-filter/userspace/iptables -A FORWARD $i -j DROP || exit 1
    ./rcv_ip 2 1 < /dev/tap1 > $TMPFILE &
    sleep 1
    ./gen_ip $TAP0NET.2 $TAP1NET.2 100 1 8 0 55 57 > /dev/tap0

    if wait %./rcv_ip; then :
    else
	echo ./rcv_ip failed for \`$i\':
	cat $TMPFILE
	exit 1
    fi
    ../packet-filter/userspace/iptables -F FORWARD || exit 1
done

exit 0
