#! /bin/sh

# Script to test rmmod of ftp module.

# Need job control.
set -m

insmod ../conntrack/extentions/ip_conntrack_ftp.o || exit 1

# Handshake, then send FTP PORT command, then PASV response.
./gen_ip $TAP0NET.2 $TAP1NET.2 100 6 1024 21 SYN > /dev/tap0 || exit 1
./gen_ip $TAP1NET.2 $TAP0NET.2 100 6 21 1024 SYN/ACK > /dev/tap1 || exit 1
./gen_ip $TAP0NET.2 $TAP1NET.2 100 6 1024 21 ACK > /dev/tap0 || exit 1

# FTP PORT COMMAND
echo -e "PORT `echo $TAP0NET.2 | tr . ,`,7,236\\r" |
./gen_ip $TAP0NET.2 $TAP1NET.2 100 6 1024 21 ACK DATA > /dev/tap0 || exit 1

if [ "`cat /proc/net/ip_conntrack | grep ^EXPECTING:`" != "EXPECTING: proto=6 src=$TAP1NET.2 dst=$TAP0NET.2 sport=0 dport=2028 " ]
then
    echo Have strange PORT expecting:
    cat /proc/net/ip_conntrack
    exit 1
fi

rmmod ip_conntrack_ftp || exit 1

# Just one entry: normal TCP.
if grep "^tcp      6 [0-9]* ESTABLISHED src=$TAP0NET.2 dst=$TAP1NET.2 sport=1024 dport=21 src=$TAP1NET.2 dst=$TAP0NET.2 sport=21 dport=1024 $" /proc/net/ip_conntrack < /dev/null && [ `wc -l < /proc/net/ip_conntrack` == 1 ]
then :
else    
    echo Somethign wierd in conntrack:
    cat /proc/net/ip_conntrack
    exit 1
fi

# Still works like expected.
echo -e "PORT `echo $TAP0NET.2 | tr . ,`,7,236\\r" |
./gen_ip $TAP0NET.2 $TAP1NET.2 100 6 1024 21 ACK DATA > /dev/tap0 || exit 1

if grep "^tcp      6 [0-9]* ESTABLISHED src=$TAP0NET.2 dst=$TAP1NET.2 sport=1024 dport=21 src=$TAP1NET.2 dst=$TAP0NET.2 sport=21 dport=1024 $" /proc/net/ip_conntrack < /dev/null && [ `wc -l < /proc/net/ip_conntrack` == 1 ]
then :
else    
    echo Somethign wierd in conntrack after new traffic:
    cat /proc/net/ip_conntrack
    exit 1
fi

exit 0
