#! /bin/sh

# Tests for the TCP parts of ip nat rules.

# Need job control.
set -m

../NAT/userspace/ipnatctl -I -s $TAP0NET.2 -d $TAP1NET.2 -b source -p tcp -t $TAP0NET.4 --sport 1 --dport 2 || exit 1

# Receive four packets.
./rcv_ip 2 4 < /dev/tap1 > $TMPFILE &
sleep 1

# Only one of these should match.
./gen_ip $TAP0NET.2 $TAP1NET.2 100 6 1 1 SYN > /dev/tap0
./gen_ip $TAP0NET.2 $TAP1NET.2 100 6 1 2 SYN > /dev/tap0
./gen_ip $TAP0NET.2 $TAP1NET.2 100 6 2 1 SYN > /dev/tap0
./gen_ip $TAP0NET.2 $TAP1NET.2 100 6 2 2 SYN > /dev/tap0

../NAT/userspace/ipnatctl -D -s $TAP0NET.2 -d $TAP1NET.2 -b source -p tcp -t $TAP0NET.4 --sport 1 --dport 2 || exit 1

if wait %./rcv_ip; then :
else
    echo ./rcv_ip failed:
    cat $TMPFILE
    exit 1
fi

for answer in "$TAP0NET.2 $TAP1NET.2 100 6 1 1 SYN" \
	      "$TAP0NET.4 $TAP1NET.2 100 6 1 2 SYN" \
	      "$TAP0NET.2 $TAP1NET.2 100 6 2 1 SYN" \
	      "$TAP0NET.2 $TAP1NET.2 100 6 2 2 SYN"
do
    read LINE
    if [ "$LINE" != "$answer" ]
    then
	echo Unexpected answer "$LINE"
	exit 1
    fi
done < $TMPFILE

exit 0
