#! /bin/sh

# Test the case where the NAT space fills up (packets should be dropped).

# Need job control.
set -m

../NAT/userspace/ipnatctl -I -s $TAP0NET.2 -d $TAP1NET.2 -b source -p udp -t $TAP0NET.4 --to-ports 1-10 || exit 1

# Receive 10 packets.
./rcv_ip 2 10 < /dev/tap1 > $TMPFILE &
sleep 1

./gen_ip $TAP0NET.2 $TAP1NET.2 100 17 100 1 > /dev/tap0
./gen_ip $TAP0NET.2 $TAP1NET.2 100 17 101 1 > /dev/tap0
./gen_ip $TAP0NET.2 $TAP1NET.2 100 17 102 1 > /dev/tap0
./gen_ip $TAP0NET.2 $TAP1NET.2 100 17 103 1 > /dev/tap0
./gen_ip $TAP0NET.2 $TAP1NET.2 100 17 104 1 > /dev/tap0
./gen_ip $TAP0NET.2 $TAP1NET.2 100 17 105 1 > /dev/tap0
./gen_ip $TAP0NET.2 $TAP1NET.2 100 17 106 1 > /dev/tap0
./gen_ip $TAP0NET.2 $TAP1NET.2 100 17 107 1 > /dev/tap0
./gen_ip $TAP0NET.2 $TAP1NET.2 100 17 108 1 > /dev/tap0
./gen_ip $TAP0NET.2 $TAP1NET.2 100 17 109 1 > /dev/tap0

if wait %./rcv_ip; then :
else
    echo ./rcv_ip failed:
    cat $TMPFILE
    exit 1
fi

# Shouldn't receive 11th packet.
./rcv_ip 2 1 < /dev/tap1 > $TMPFILE &
sleep 1

./gen_ip $TAP0NET.2 $TAP1NET.2 100 17 110 1 > /dev/tap0

../NAT/userspace/ipnatctl -D -s $TAP0NET.2 -d $TAP1NET.2 -b source -p udp -t $TAP0NET.4 --to-ports 1-10 || exit 1

if wait %./rcv_ip
then 
    echo ./rcv_ip succeeded:
    cat $TMPFILE
    exit 1
fi


exit 0


