#! /bin/sh

# Script to test ftp module's sack option removal code.

# Need job control.
set -m

insmod ../conntrack/extentions/ip_conntrack_ftp.o || exit 1
insmod ../NAT/extentions/ip_nat_ftp.o || exit 1

# Generate initial packets: one with no options, one with an MSS
# option, one with a SACK_PERM option, one with MSS + PERM, one with
# PERM + MSS.

./rcv_ip 2 5 < /dev/tap1 > $TMPFILE &
sleep 1

./gen_ip $TAP0NET.2 $TAP1NET.2 100 6 1024 21 SYN > /dev/tap0 || exit 1
./gen_ip $TAP0NET.2 $TAP1NET.3 100 6 1024 21 SYN OPT=2,4,5,220 > /dev/tap0 || exit 1
./gen_ip $TAP0NET.2 $TAP1NET.4 100 6 1024 21 SYN OPT=4,2,0,0 > /dev/tap0 || exit 1
./gen_ip $TAP0NET.2 $TAP1NET.5 100 6 1024 21 SYN OPT=2,4,5,220,4,2,0,0 > /dev/tap0 || exit 1
./gen_ip $TAP0NET.2 $TAP1NET.6 100 6 1024 21 SYN OPT=4,2,0,0,2,4,5,220 > /dev/tap0 || exit 1

if wait %./rcv_ip; then :
else
    echo ./rcv_ip failed:
    cat $TMPFILE
    exit 1
fi

if [ "`cat $TMPFILE`" != "$TAP0NET.2 $TAP1NET.2 100 6 1024 21 SYN 
$TAP0NET.2 $TAP1NET.3 100 6 1024 21 SYN OPT=2,4,5,220
$TAP0NET.2 $TAP1NET.4 100 6 1024 21 SYN OPT=0,0,0,0
$TAP0NET.2 $TAP1NET.5 100 6 1024 21 SYN OPT=2,4,5,220,0,0,0,0
$TAP0NET.2 $TAP1NET.6 100 6 1024 21 SYN OPT=0,0,0,0,2,4,5,220" ]
then
    echo Unexpected SYN mangling:
    echo \`"`cat $TMPFILE`"\'
    exit 1
fi

# Force timeout of TCP connections.
./gen_ip $TAP1NET.2 $TAP0NET.2 100 6 21 1024 RST > /dev/tap0 || exit 1
./gen_ip $TAP1NET.3 $TAP0NET.2 100 6 21 1024 RST > /dev/tap0 || exit 1
./gen_ip $TAP1NET.4 $TAP0NET.2 100 6 21 1024 RST > /dev/tap0 || exit 1
./gen_ip $TAP1NET.5 $TAP0NET.2 100 6 21 1024 RST > /dev/tap0 || exit 1
./gen_ip $TAP1NET.6 $TAP0NET.2 100 6 21 1024 RST > /dev/tap0 || exit 1

sleep 10
rmmod ip_nat_ftp || exit 1
rmmod ip_conntrack_ftp || exit 1

exit 0
