#! /bin/sh

# Script to test ftp module removal: should cause forgetting about
# module.

insmod ../conntrack/extentions/ip_conntrack_ftp.o || exit 1
insmod ../NAT/extentions/ip_nat_ftp.o || exit 1

# Normal NAT test.
../NAT/userspace/ipnatctl -I -s $TAP0NET.2 -b source -t $TAP0NET.100 || exit 1

# Generate initial packets: handshake, then FTP PORT command.
./gen_ip $TAP0NET.2 $TAP1NET.2 100 6 1024 21 SYN > /dev/tap0 || exit 1
./gen_ip $TAP1NET.2 $TAP0NET.100 100 6 21 1024 SYN/ACK > /dev/tap1 || exit 1
./gen_ip $TAP0NET.2 $TAP1NET.2 100 6 1024 21 ACK > /dev/tap0 || exit 1

echo -e "PORT `echo $TAP0NET.2 | tr . ,`,7,236\\r" |
./gen_ip $TAP0NET.2 $TAP1NET.2 100 6 1024 21 ACK DATA > /dev/tap0 || exit 1

# rmmod it.
rmmod ip_nat_ftp || exit 1

# Should be forgotten (map should do start new connection).
./gen_ip $TAP0NET.2 $TAP1NET.2 100 6 1024 21 SYN > /dev/tap0 || exit 1
if grep "^tcp      6 [0-9]* SYN_SENT src=$TAP0NET.2 dst=$TAP1NET.2 sport=1024 dport=21 \[UNREPLIED\] src=$TAP1NET.2 dst=$TAP0NET.100 sport=21 dport=1024 $" /proc/net/ip_conntrack > /dev/null && [ `wc -l < /proc/net/ip_conntrack` == 1 ]
then :
else    
    echo Somethign wierd in conntrack after ftp removal:
    cat /proc/net/ip_conntrack
    exit 1
fi

rmmod ip_conntrack_ftp || exit 1

exit 0
