#! /bin/sh

# Simple masquerade setup: one rule and deny policy.

# Need job control.
set -m

ipchains -P forward DENY || exit 1
ipchains -A forward -i tap1 -j MASQ || exit 1

./rcv_ip 2 1 < /dev/tap1 > $TMPFILE &
sleep 1

# Send some traffic: SYN say.
./gen_ip $TAP0NET.2 $TAP1NET.2 100 6 1024 80 SYN > /dev/tap0 || exit 1

if wait %./rcv_ip; then :
else
    echo ./rcv_ip failed after SYN:
    cat $TMPFILE
    exit 1
fi

if [ "`cat $TMPFILE`" != "$TAP1NET.1 $TAP1NET.2 100 6 61000 80 SYN " ]
then
    echo Unexpected masq result:
    cat $TMPFILE
    exit 1
fi

# Send reply.
./rcv_ip 2 1 < /dev/tap0 > $TMPFILE &
sleep 1

./gen_ip $TAP1NET.2 $TAP1NET.1 101 6 80 61000 SYN/ACK > /dev/tap1 || exit 1

if wait %./rcv_ip; then :
else
    echo ./rcv_ip failed after SYN,ACK:
    cat $TMPFILE
    exit 1
fi

if [ "`cat $TMPFILE`" != "$TAP1NET.2 $TAP0NET.2 101 6 80 1024 SYN/ACK " ]
then
    echo Unexpected masq reply result:
    cat $TMPFILE
    exit 1
fi

# New packet through tap1 should get denied, even if src = TAP0NET.
./rcv_ip 2 1 < /dev/tap0 > $TMPFILE &
sleep 1

./gen_ip $TAP0NET.2 $TAP0NET.2 102 6 80 61000 SYN/ACK > /dev/tap1 || exit 1

if wait %./rcv_ip
then
    echo Packet got past deny policy:
    cat $TMPFILE
    exit 1
fi

if [ "`ipchains -n -L -v`" != "Chain input (policy ACCEPT: 3 packets, 303 bytes):
Chain forward (policy DENY: 1 packets, 102 bytes):
 pkts bytes target     prot opt    tosa tosx  ifname     mark       outsize  source                destination           ports
    1   100 MASQ       all  ------ 0xFF 0x00  tap1                           0.0.0.0/0            0.0.0.0/0             n/a
Chain output (policy ACCEPT: 2 packets, 201 bytes):" ]
then
    echo Unexpected ipchains -n -L -v:
    echo "`ipchains -n -L -v`"
    exit 1
fi

exit 0
